#ifndef _BOODSKAP_MESSAGE_H
#define _BOODSKAP_MESSAGE_H

#include <ArduinoJson.h>
#include "DeviceModel.h"

class BoodskapMessage
{

  public:

    BoodskapMessage(JsonBuffer& buffer);

    BoodskapMessage(unsigned int messageId, JsonBuffer& buffer, const char* domainKey, const char* assetId, const char* apiKey, const char* fwVersion, DeviceModel devModel);

    JsonObject& get();

    JsonObject& header();

    JsonObject& data();

    void clear();

    void compact();

    void constructAck(bool ack);

    JsonObject& set(const char* field, uint8_t val);

    JsonObject& set(const char* field, bool val);

    JsonObject& set(const char* field, int val);

    JsonObject& set(const char* field, uint16_t val);

    JsonObject& set(const char* field, uint32_t val);

    JsonObject& set(const char* field, float val);

    JsonObject& set(const char* field, double val);

    JsonObject& set(const char* field, long val);

    JsonObject& set(const char* field, const char* val);

    JsonObject& set(const char* field, String val);

    static bool parse(BoodskapMessage& msg, const char* json);

  private:

    const char* _domainKey;
    const char* _assetId;
    const char* _apiKey;
    const char* _fwVersion;
    const DeviceModel _devModel;
    JsonObject* _msg;
    JsonObject* _header;
    JsonObject* _data;
};

#endif //_BOODSKAP_MESSAGE_H
